SystemOrganization addCategory: #'Parasol-Convenience'!

!BPActions methodsFor: '*Parasol-Convenience' stamp: 'AndyKellens 4/21/2015 14:03'!
click: anElement atOffset: anOffset

	self moveToElement: anElement offset: anOffset.
	action addAction: (BPClickAction driver: driver buttonNumber: 1)! !

!BPActions methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 7/9/2012 14:48'!
contextClick: webElement at: aPoint
	
	self moveToElement: webElement offset: aPoint.
	action addAction: (BPClickAction driver: driver buttonNumber: 2).! !

!BPActions methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:17'!
drag: sourceWebElement andDrop: targetWebElement at: aPoint

	self
		clickAndHold: sourceWebElement;
		moveToElement: targetWebElement offset: aPoint;
		releaseButton! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 5/4/2015 09:18'!
clickAt: aPoint
	
	(BPActions driver: driver)
		click: self atOffset: aPoint;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:16'!
contextClick
	
	(BPActions driver: driver)
		contextClick: self;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:16'!
contextClickAt: aPoint
	
	(BPActions driver: driver)
		contextClick: self at: aPoint;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'CarstenHaerle 9/11/2014 16:54'!
cssClassNames
	^ (((self getAttribute: 'class') ifNil: [ String new ]) subStrings: ' ') select: [ :className | className isEmpty not ]! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'JohanBrichau 7/7/2012 13:16'!
doubleClick
	
	(BPActions driver: driver)
		doubleClick: self;
		perform.! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'ThomasCleenewerck 5/30/2013 11:42'!
getDirectTextIngoreTextInDescandants
	| children text |
	children := self findElementsByXPath: '*'.
	text := self getText.
	"elements can occur before the text nodes and after one, hence we cannot simply trim from the start nor from the rear"
	children do: [ :c | text := text copyReplaceAll: c getText with: '' ].
	^text trimBoth  ! !

!BPWebElement methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 7/9/2012 15:10'!
sendKey: character

	^ self sendKeys: (String with: character)! !

!BPCapabilityPlatform class methodsFor: '*Parasol-Convenience-accessing' stamp: 'KrisGybels 10/9/2015 13:07'!
any

	^ self valueOf: 'ANY'
! !

!BPCapabilityPlatform class methodsFor: '*Parasol-Convenience-accessing' stamp: 'KrisGybels 10/9/2015 13:06'!
mac

	^ self valueOf: 'MAC'
! !

!BPCapabilityPlatform class methodsFor: '*Parasol-Convenience-accessing' stamp: 'KrisGybels 10/9/2015 13:23'!
unix

	^ self valueOf: 'UNIX'
! !

!BPCapabilityPlatform class methodsFor: '*Parasol-Convenience-accessing' stamp: 'KrisGybels 10/9/2015 13:07'!
windows

	^ self valueOf: 'WINDOWS'
! !

!BPCapabilityPlatform methodsFor: '*Parasol-Convenience-testing' stamp: 'KrisGybels 10/9/2015 13:23'!
isMacOSX

	^ self is: BPCapabilityPlatform mac
! !

!BPCapabilityPlatform methodsFor: '*Parasol-Convenience-testing' stamp: 'KrisGybels 10/9/2015 13:23'!
isUnix

	^ self is: BPCapabilityPlatform unix
! !

!BPCapabilityPlatform methodsFor: '*Parasol-Convenience-testing' stamp: 'KrisGybels 10/9/2015 13:23'!
isWindows

	^ self is: BPCapabilityPlatform windows
! !

!BPKeyboard methodsFor: '*parasol-convenience' stamp: 'JohanBrichau 2/28/2014 17:18'!
releaseModifierKeys
	self sendKeys: (String with: BPKeys null) ! !

!BPKeyboard methodsFor: '*parasol-convenience' stamp: 'JohanBrichau 1/21/2013 14:49'!
sendAltKey
	self sendKeys: (BPKeys alt) asString! !

!BPRemoteWebDriver methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 10/10/2012 11:31'!
openAndSwitchToNewWindow

	| handle |
	handle := self openNewWindow.
	self switchTo window: handle.
	^ handle! !

!BPRemoteWebDriver methodsFor: '*Parasol-Convenience' stamp: 'KrisGybels 10/10/2012 11:31'!
openNewWindow

	self executeScript: 'window.open()' with: #(). 
	^ self getWindowHandles last.! !
